<?php
/*
 * J!Blank Template for Joomla 1.5.x
 * @author joomla-book.ru
 * @email admin@joomla-book.ru
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
include (JPATH_BASE.DS.'templates'.DS.$this->template.DS.'php'.DS.'define.php');
echo '<?xml version="1.0" encoding="utf-8"?'.">\n"; ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $this->language; ?>" lang="<?php echo $this->language; ?>" dir="<?php echo $this->direction; ?>">
<head>
<jdoc:include type="head" /></head>
<body>
	<div id="page" class="w1000">
		<div class="content">
			<!-- Простой вывод позиции "top" -->
			<jdoc:include type="modules" name="top" />   

			<!-- Вывод текущей даты -->
			<div>Вывод даты: <?php echo $tpl['date'];?></div>

			<!-- Если в позиции "user1" есть модули, то показать и обрамить таблицей -->
			<?php if($this->countModules('user1')) : ?>
				<table><tr><td>
				<jdoc:include type="modules" name="user1" />
				</td></tr></table>
			<?php endif; ?>

			<!-- Если есть модули в "user2" ИЛИ "user3" то отобразить -->
			<?php if($this->countModules('user2 or user3')) : ?>
				<jdoc:include type="modules" name="user2" />
				<!-- Если пользователь зарегистрирован и вошел (не гость), отобразить "user3" -->
				<?php if (!$tpl['guest']) :?>
					<jdoc:include type="modules" name="user3" />
				<?php endif;?>
			<?php endif; ?>

			<!-- Вывод позиции "search" и обрамление её Chrome-стилем "table"  -->
			<jdoc:include type="modules" name="search" style="table" />

			<!-- Если есть что-то в буфере "message", отобразить --> 
			<?php if ($this->getBuffer('message')) : ?>
				<div id="jmessage">
				<h3><?php echo JText::_('Message'); ?></h3>
					<div><jdoc:include type="message" /></div>
				</div>
			<?php endif; ?>


			<!-- Если есть под меню от главного меню то отображает позицию "left" -->
			<?php if($this->countMenuChildren()) : ?>
				<!-- Пример использования собственого Chrome-стиля -->
				<jdoc:include type="modules" name="left" style="division" headerLevel="4" />
			<?php endif; ?>

			<!-- Вывода контента (компонента) -->
			<div id="content">
				<?php if (!$tpl['front']) : ?>
					<div id="breadcrumb"><jdoc:include type="modules" name="breadcrumb" /></div>
				<?php endif;?>

				<?php if ($this->getBuffer('message')) : ?>
					<div id="system-message"><jdoc:include type="message" /></div>
				<?php endif; ?>

				<div class="content">
					<jdoc:include type="modules" name="pre_component" />
					<jdoc:include type="component" />
					<jdoc:include type="modules" name="post_component" />
				</div>

			</div>

			<!-- Если есть модули в позиии "right" и вид - "article", отоброжаем содержимое позиции -->
			<?php if($this->countModules('right') and JRequest::getVar('view') != 'article') : ?>
				<jdoc:include type="modules" name="right" />
			<?php endif; ?>

			<!-- Вывод встроенной отладки сайта (для рабочих проектов можно не включать) -->
			<div id="debug"><jdoc:include type="modules" name="debug" /></div>

		</div>
	</div>
</body>
</html>
